#include "m_pd.h"
#include "math.h"
 
typedef struct best_match
{
  t_object x_ob;
  int x1_i[100],  x1_s[100], x2_i[100], x2_s[100];
  float x1_x[100], x1_y[100], x2_x[100], x2_y[100];
  float x2_a[100], x2_a2[100], x2_a3[100], x2_a4[100], x2_a5[100], x2_a6[100], x1_a[100], x1_a2[100], x1_a3[100], x1_a4[100], x1_a5[100], x1_a6[100];
  float max_dist;
  int prev_pts, pts, report;
  t_outlet *out01, *out02, *out03;
} t_best_match;

void best_match_xy(t_best_match *x, t_symbol *selector, int argcount, t_atom *argvec)
{
    int i;
  //  x->pts = ;
    for (i = 0; i < argcount; i++) { 
    	if (argvec[i].a_type == A_FLOAT) {
			if	(i == 0)	{x->x2_i[x->pts] = (int) argvec[i].a_w.w_float;}
			else if (i == 1)	{x->x2_x[x->pts] =  argvec[i].a_w.w_float;}
			else if (i == 2)	{x->x2_y[x->pts] =  argvec[i].a_w.w_float;}
			else if (i == 3)	{x->x2_a[x->pts] =  argvec[i].a_w.w_float;}
			else if (i == 4)	{x->x2_a2[x->pts] = argvec[i].a_w.w_float;}
			else if (i == 5)	{x->x2_a3[x->pts] = argvec[i].a_w.w_float;}
			else if (i == 6)	{x->x2_a4[x->pts] = argvec[i].a_w.w_float;}
			else if (i == 7)	{x->x2_a5[x->pts] = argvec[i].a_w.w_float;}
			else if (i == 8)	{x->x2_a6[x->pts] = argvec[i].a_w.w_float;}
			x->x2_s[x->pts] = 1;
	}  
    }
    x->pts++; 
}

void best_match_ft1(t_best_match *x, t_floatarg g)
{
    x->max_dist = g;
}

void best_match_xy_spit(t_best_match *x)
{
//	post("new");
	int i, j, new_pts, j_tmp, i_tmp, assigned;
	int free_i[100];
	t_atom at[12];
	double dist, dist_temp;
	float tx, ty, tmp;
	j_tmp = i_tmp = assigned = 0;

	new_pts = x->pts - x->prev_pts;
	for (i = 0; i < 100; i++) {
		free_i[i] = 1;
	}
	
 	if (new_pts >= 0) { // if there are more or equal new pts than previous pts
	post("newpts>=0");
		for (i = 0; i < x->prev_pts; i++) { // for each previous pt
			dist_temp = 1000000000;
			for (j = 0; j < x->pts; j++) {  // find the closest new one.
				if (x->x2_s[j] == 1) {
					j_tmp = -1;
					tx = (x->x1_x[i] - x->x2_x[j]);
					ty = (x->x1_y[i] - x->x2_y[j]);
					tmp = tx*tx + ty*ty;
					dist = sqrtf(tmp);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp = dist;
						j_tmp = j; // store the index of the old one...
					}	
				}
				else continue;
			}
	//		post("assign norms, index = %d", x->x1_i[i]);
			if (j_tmp >= 0) {
				x->x2_s[j_tmp]	= 0;			// set the state of the new tip to 0
				x->x1_s[i]	= 0;
				i_tmp = x->x2_i[j_tmp] = x->x1_i[i];	// assign the index of previous tip
				free_i[i_tmp]	= 0;
				assigned++;
			}
			if (assigned == x->pts) {
				break;
			}
		} 
		for (i = 0; i < 100; i++) { // for each previous pt
			dist_temp = 10000000;
			for (j = 0; j < x->pts; j++) {  // find the closest new one.
				if (x->x2_s[j] == 1 && free_i[i] == 1) {
					j_tmp = -1;
					tx = (x->x1_x[i] - x->x2_x[j]);
					ty = (x->x1_y[i] - x->x2_y[j]);
					tmp = tx*tx + ty*ty;
					dist = sqrtf(tmp);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp = dist;
						j_tmp	  = j;
					}	
				}
				else continue;
			}
	//		post("assign norms, index = %d", x->x1_i[i]);
			if (j_tmp >= 0) {
				x->x2_s[j_tmp]	= 0;			// set the state of the new tip to 0
				i_tmp = x->x2_i[j_tmp] = x->x1_i[i];	// assign the index of previous tip
				free_i[i_tmp]	= 0;
				assigned++;
			}
			if (assigned == x->pts) {
				break;
			}
		} 
		while (assigned < x->pts) {
			for (i = 0; i < x->pts; i++) { // each old point assign a new index
				if (x->x2_s[i] == 1) {
					x->x2_s[i] = 0;
					for (j = 0; j < 100; j++) {
						if (free_i[j] == 1) {
							free_i[j] = 0;
							x->x2_i[i] = j;
						//	post("assign extra, index = %d", j);
							new_pts--;
							assigned++;
							break;
						}
					}
				}
			}
		}
	}
	else if (new_pts < 0) { // if there are less new pts than previous pts
	post("newpts<0");
		for (i = 0; i < x->pts; i++) { // for each new pt
			dist_temp = 10000000;
			for (j = 0; j < 100; j++) {  // find the closest old one.
				if (free_i[j] == 1) {
					j_tmp = -1;
					tx = (x->x1_x[j] - x->x2_x[i]);
					ty = (x->x1_y[j] - x->x2_y[i]);
					tmp = tx*tx + ty*ty;
					dist = sqrtf(tmp);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp	= dist;
						j_tmp		= j;
					}	
				}
				else continue;
			}
	//		post("assign norms, index = %d", x->x1_i[i]);
			if (j_tmp >= 0) {
				x->x2_s[i]		= 0;		// set the state of the new tip to 0
				i_tmp = x->x2_i[i]	= x->x1_i[j_tmp];	// assign the index of previous tip			
				free_i[i_tmp]	= 0;
				assigned++;
			}
			if (assigned == x->pts) {
				break;
			}	
		} 			 
	}
	for (i = 0; i < x->pts; i++) {
		SETFLOAT(at,	x->x2_i[i]);
		SETFLOAT(at+1,	x->x2_x[i]);
		SETFLOAT(at+2,	x->x2_y[i]);
		SETFLOAT(at+3,	x->x2_a[i]);
		SETFLOAT(at+4,	x->x2_a2[i]);
		SETFLOAT(at+5,	x->x2_a3[i]);
		SETFLOAT(at+6,	x->x2_a4[i]);
		SETFLOAT(at+7,	x->x2_a5[i]);
		SETFLOAT(at+8,	x->x2_a6[i]);
		outlet_list(x->out01, 0, 9, at);
	}
	for (i = 0; i < x->pts; i++) {
		x->x1_i[i]	= x->x2_i[i]; 
		x->x1_x[i]	= x->x2_x[i];
		x->x1_y[i]	= x->x2_y[i];
		x->x1_a[i]	= x->x2_a[i];
		x->x1_a2[i]	= x->x2_a2[i];
		x->x1_a3[i]	= x->x2_a3[i];
		x->x1_a4[i]	= x->x2_a4[i];
		x->x1_a5[i]	= x->x2_a5[i];
		x->x1_a6[i]	= x->x2_a6[i];
		x->x1_s[i]	= 1;
	}
	x->prev_pts = x->pts;
	x->pts = 0;
	SETFLOAT(at,	1);
	outlet_list(x->out02, 0, 1, at);
}

t_class *best_match_class;

void *best_match_new(t_symbol *selector, int argcount, t_atom *argvec)
{
    t_best_match *x = (t_best_match *)pd_new(best_match_class);
	inlet_new(&x->x_ob, &x->x_ob.ob_pd, gensym("float"), gensym("ft1"));
	x->prev_pts = 0;
	x->pts = 0;
	x->max_dist = 30;
	x->out01 = outlet_new(&x->x_ob, &s_list);
	x->out02 = outlet_new(&x->x_ob, &s_list);
	x->out03 = outlet_new(&x->x_ob, &s_list);
    return (void *)x;
}

void best_match_setup(void)  {
    	/* We specify "A_GIMME" as creation argument for both the creation
	routine and the method (callback) for the "xy" message.  */
    best_match_class = class_new(gensym("best_match"), (t_newmethod)best_match_new,
    	0, sizeof(t_best_match), 0, A_GIMME, 0);
    	class_addmethod(best_match_class, (t_method)best_match_xy, gensym("xy"), A_GIMME, 0);
	class_addmethod(best_match_class, (t_method)best_match_xy_spit, gensym("xy_spit"), 0);
	class_addmethod(best_match_class, (t_method)best_match_ft1, gensym("ft1"), A_FLOAT, 0);
}

