#include "m_pd.h"
#include "math.h"

typedef struct best_match
{
  t_object x_ob;
	
  int x1_i[1000], x1_s[1000], x2_i[1000], x2_s[1000];
	float x1_x[1000], x1_y[1000], x2_x[1000], x2_y[1000];
  float x1_a1[1000], x1_a2[1000], x1_a3[1000], x1_a4[1000], x1_a5[1000], x1_a6[1000], x1_a7[1000], x1_a8[1000], x1_a9[1000], x1_a10[1000], x1_a11[1000], x1_a12[1000], x1_a13[1000], x1_a14[1000];
  float x2_a1[1000], x2_a2[1000], x2_a3[1000], x2_a4[1000], x2_a5[1000], x2_a6[1000], x2_a7[1000], x2_a8[1000], x2_a9[1000], x2_a10[1000], x2_a11[1000], x2_a12[1000], x2_a13[1000], x2_a14[1000];
  int i_reg1[1000], i_reg2[1000];
  float max_dist;
  int prev_pts, pts, report;
  t_outlet *out01, *out02, *out03;
} t_best_match;

void best_match_xy(t_best_match *x, t_symbol *selector, int argcount, t_atom *argvec)
{
    int i;
    for (i = 0; i < argcount; i++) {
    	if (argvec[i].a_type == A_FLOAT) {
			if	(i == 0)	{x->x2_i[x->pts] = (int) argvec[i].a_w.w_float;}
			else if (i == 1)	{x->x2_x[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 2)	{x->x2_y[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 3)	{x->x2_a1[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 4)	{x->x2_a2[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 5)	{x->x2_a3[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 6)	{x->x2_a4[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 7)	{x->x2_a5[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 8)	{x->x2_a6[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 9)	{x->x2_a7[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 10)	{x->x2_a8[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 11)	{x->x2_a9[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 12)	{x->x2_a10[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 13)	{x->x2_a11[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 14)	{x->x2_a12[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 15)	{x->x2_a13[x->pts] = 	 argvec[i].a_w.w_float;}
			else if (i == 16)	{x->x2_a14[x->pts] = 	 argvec[i].a_w.w_float;}
			x->x2_s[x->pts] = 1; 
		}   
	}
//	post("i = %d, x = %d, y = %d", x->x2_i[x->pts], x->x2_x[x->pts], x->x2_y[x->pts]);
//	post("pts = %d", x->pts);
	x->pts++; 
}

void best_match_ft1(t_best_match *x, t_floatarg g)
{
    x->max_dist = g;
	post("maxdist = %f", x->max_dist);
}

void best_match_clear(t_best_match *x)
{
	int z, j, i;
	t_atom at[3];	
	z = 0;
	for (j = 0; j < x->prev_pts; j++) {  // for every old point
		if (x->x1_s[j] == 1) {
			x->i_reg1[z] = -2;
			x->i_reg2[z] = x->x1_i[j];
			z++;
		}
		if (z == x->prev_pts) break;
	}
	for (i = 0; i < z; i++) {
		SETFLOAT(at,	x->i_reg1[i]);
		SETFLOAT(at+1,	x->i_reg2[i]);
		outlet_list(x->out03, 0, 2, at);
	}
	x->prev_pts = x->pts = 0;
}

void best_match_xy_spit(t_best_match *x)
{
//	post("new");
	int i, j, z, new_pts, j_tmp, i_tmp, assigned;
	int free_i[100];
	t_atom at[18];
	double dist, dist_temp;
	j_tmp = i_tmp = assigned = z = 0;

	new_pts = x->pts - x->prev_pts;
	for (i = 0; i < 100; i++) {
		free_i[i] = 1;
	}	
 	if (new_pts >= 0) { // if there are more or equal new pts than previous pts //	post (">=");
		for (i = 0; i < x->prev_pts; i++) { // for each previous pt
			dist_temp = 10000000;
			j_tmp = -1;
			for (j = 0; j < x->pts; j++) {  // find the closest new one.
				if (x->x2_s[j] == 1) {
					dist = sqrt(((x->x1_x[i] - x->x2_x[j])*(x->x1_x[i] - x->x2_x[j])) + 
								((x->x1_y[i] - x->x2_y[j])*(x->x1_y[i] - x->x2_y[j]))	);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp	= dist;
						j_tmp		= j; //		post("dist = %f", dist);
					}	
				}
				else continue;
			}
			if (j_tmp >= 0) {
				x->x2_s[j_tmp]		= 0;			// set the state of the new tip to 0
				x->i_reg1[z] 		= x->x2_i[j_tmp];
				x->x2_i[j_tmp]		= x->x1_i[i];		// assign the index of previous tip
				x->i_reg2[z] 		= x->x2_i[j_tmp];		
				free_i[x->x2_i[j_tmp]]	= 0;
				assigned++; z++;//	post("assigned %d", x->x1_i[i] );
			}
			if (assigned == x->pts) {
				break;
			}
		} 
		if (assigned < x->pts) { // the old points left behind
			for (j = 0; j < x->prev_pts; j++) {  // for every old point
				if (x->x1_s[j] == 1) {
					x->x1_s[j] = 0;
					x->i_reg1[z] = -2;
					x->i_reg2[z] = x->x1_i[j];
					free_i[x->x1_i[j]] = 0;
					z++;
				}
				if (assigned == x->prev_pts) break;
			}
		}
		while (assigned != x->pts) { //			post("while");
			for (i = 0; i < x->pts; i++) {
				if (x->x2_s[i] == 1) {
					for (j = 0; j < 100; j++) {
						if (free_i[j] == 1) {
							x->x2_s[i] = 0;
							free_i[j] = 0;
							x->x2_i[i] = j;
							x->i_reg1[z] = -1;
							x->i_reg2[z] = x->x2_i[i]; //post("assign extra, index = %d", j);
							assigned++; z++;
							break;
						}
					}
				}
			}
		}
	}
	else if (new_pts < 0) { // if there are less new pts than previous pts //	post ("<");
		for (i = 0; i < x->pts; i++) { // for each new pt
			dist_temp = 10000000;
			j_tmp = -1;
			for (j = 0; j < x->prev_pts; j++) {  // find the closest old one.
				if (x->x1_s[j] == 1) {
					dist = sqrt(((x->x1_x[j] - x->x2_x[i])*(x->x1_x[j] - x->x2_x[i])) + 
							((x->x1_y[j] - x->x2_y[i])*(x->x1_y[j] - x->x2_y[i]))	);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp	= dist;
						j_tmp		= j;
//						post("dist = %f", dist);
					}	
				}
				else continue;
			}
			if (j_tmp >= 0) {
				x->x1_s[j_tmp]		= 0;		// set the state of the new tip to 0
				x->i_reg1[z] 		= x->x2_i[i];
				x->x2_i[i]		= x->x1_i[j_tmp];	// assign the index of previous tip		
				x->i_reg2[z] 		= x->x2_i[i];
				assigned++; 
				z++; //		post("assigned %d", x->x1_i[j_tmp] );
			}		
			if (assigned == x->pts) {
				break;
			}	
		} 
		for (j = 0; j < x->prev_pts; j++) {  // for every old point
			if (x->x1_s[j] == 1) {
				x->i_reg1[z] = -2;
				x->i_reg2[z] = x->x1_i[j];
				z++;
			}
			if (z == x->prev_pts) break;
		}
	}			 
	for (i = 0; i < x->pts; i++) {
		SETFLOAT(at,	x->x2_i[i]);
		SETFLOAT(at+1,	x->x2_x[i]);
		SETFLOAT(at+2,	x->x2_y[i]);
		SETFLOAT(at+3,	x->x2_a1[i]);
		SETFLOAT(at+4,	x->x2_a2[i]);
		SETFLOAT(at+5,	x->x2_a3[i]);
		SETFLOAT(at+6,	x->x2_a4[i]);
		SETFLOAT(at+7,	x->x2_a5[i]);
		SETFLOAT(at+8,	x->x2_a6[i]);
		SETFLOAT(at+9,	x->x2_a7[i]);
		SETFLOAT(at+10,	x->x2_a8[i]);
		SETFLOAT(at+11,	x->x2_a9[i]);
		SETFLOAT(at+12,	x->x2_a10[i]);
		SETFLOAT(at+13,	x->x2_a11[i]);
		SETFLOAT(at+14,	x->x2_a12[i]);
		SETFLOAT(at+15,	x->x2_a13[i]);
		SETFLOAT(at+16,	x->x2_a14[i]);
		outlet_list(x->out01, 0, 17, at);
	}
	for (i = 0; i < x->pts; i++) {
		x->x1_i[i]	= x->x2_i[i]; 
		x->x1_x[i]	= x->x2_x[i];
		x->x1_y[i]	= x->x2_y[i];
		x->x1_a1[i]	= x->x2_a1[i];
		x->x1_a2[i]	= x->x2_a2[i];
		x->x1_a3[i]	= x->x2_a3[i];
		x->x1_a4[i]	= x->x2_a4[i];
		x->x1_a5[i]	= x->x2_a5[i];
		x->x1_a6[i]	= x->x2_a6[i];
		x->x1_a7[i]	= x->x2_a7[i];
		x->x1_a8[i]	= x->x2_a8[i];
		x->x1_a9[i]	= x->x2_a9[i];
		x->x1_a10[i]	= x->x2_a10[i];
		x->x1_a11[i]	= x->x2_a11[i];
		x->x1_a12[i]	= x->x2_a12[i];
		x->x1_a13[i]	= x->x2_a13[i];
		x->x1_a14[i]	= x->x2_a14[i];
		x->x1_s[i]	= 1;
	}
	for (i = 0; i < z; i++) {
		SETFLOAT(at,	x->i_reg1[i]);
		SETFLOAT(at+1,	x->i_reg2[i]);
		outlet_list(x->out03, 0, 2, at);
	}
	x->prev_pts = x->pts;
	x->pts = 0;
	SETFLOAT(at,	1);
	outlet_list(x->out02, 0, 1, at);
}

t_class *best_match_class;

void *best_match_new(t_symbol *selector, int argcount, t_atom *argvec)
{
    t_best_match *x = (t_best_match *)pd_new(best_match_class);
	inlet_new(&x->x_ob, &x->x_ob.ob_pd, gensym("float"), gensym("ft1"));
	x->prev_pts = x->pts = 0;
	x->max_dist = 30;
	x->out01 = outlet_new(&x->x_ob, &s_list);
	x->out02 = outlet_new(&x->x_ob, &s_list);
	x->out03 = outlet_new(&x->x_ob, &s_list);
    return (void *)x;
}

void best_match_setup(void)
{
    	/* We specify "A_GIMME" as creation argument for both the creation
	routine and the method (callback) for the "xy" message.  */
    best_match_class = class_new(gensym("best_match"), (t_newmethod)best_match_new,
    	0, sizeof(t_best_match), 0, A_GIMME, 0);
    class_addmethod(best_match_class, (t_method)best_match_xy, gensym("xy"), A_GIMME, 0);
	class_addmethod(best_match_class, (t_method)best_match_xy_spit, gensym("xy_spit"), 0);
	class_addmethod(best_match_class, (t_method)best_match_ft1, gensym("ft1"), A_FLOAT, 0);
	class_addmethod(best_match_class, (t_method)best_match_clear, gensym("clear"), 0);
}

