#include "m_pd.h"
#include "math.h"
 
typedef struct fill0s
{
  t_object x_ob;
  int x1_i[100], x1_s[100], x2_i[100], x2_s[100];
  float x1_x[100], x1_y[100], x2_x[100], x2_y[100];
  float x2_a1[100], x2_a2[100], x2_a3[100], x2_a4[100], x2_a5[100], x2_a6[100];
  float x1_a1[100], x1_a2[100], x1_a3[100], x1_a4[100], x1_a5[100], x1_a6[100];
  int prev_pts, pts, report;
  t_outlet *out01;
} t_fill0s;

void fill0s_in(t_fill0s *x, t_symbol *selector, int argcount, t_atom *argvec)
{
    int i, j;
    j = 0;
    for (i = 0; i < argcount; i++) {
    	if (argvec[i].a_type == A_FLOAT) {
			if		(i == 0)	{
				j = (int) argvec[i].a_w.w_float;
				x->x2_s[j] = 1;
			}
			else if (i == 1)	{x->x2_x[j] =  argvec[i].a_w.w_float;}
			else if (i == 2)	{x->x2_y[j] =  argvec[i].a_w.w_float;}
			else if (i == 3)	{x->x2_a1[j] =  argvec[i].a_w.w_float;}
			else if (i == 4)	{x->x2_a2[j] =  argvec[i].a_w.w_float;}
			else if (i == 5)	{x->x2_a3[j] =  argvec[i].a_w.w_float;}
			else if (i == 6)	{x->x2_a4[j] =  argvec[i].a_w.w_float;}
			else if (i == 7)	{x->x2_a5[j] =  argvec[i].a_w.w_float;}
			else if (i == 8)	{x->x2_a6[j] =  argvec[i].a_w.w_float;}
		}   
	}
//	post("i = %d, x = %d, y = %d", x->x2_i[x->pts], x->x2_x[x->pts], x->x2_y[x->pts]);
//	post("pts = %d", x->pts);
	x->pts++; 
}

void fill0s_spit(t_fill0s *x)
{
//	post("new");
	int i, j;
	t_atom at[12];

	for (i = 0; i < x->report; i++) { // for each previous pt
		if (x->x2_s[i] = 1) {
			x->x2_s[i] = 0;
			x->x1_s[i] = 1;
			x->x1_x[i] = x->x2_x[i];
			x->x1_y[i] = x->x2_y[i];
			x->x1_a1[i] = x->x2_a1[i];
			x->x1_a2[i] = x->x2_a2[i];
			x->x1_a3[i] = x->x2_a3[i];
			x->x1_a4[i] = x->x2_a4[i];
			x->x1_a5[i] = x->x2_a5[i];
			x->x1_a6[i] = x->x2_a6[i];
		}
		else {
			x->x1_s[i] = 0;
			x->x1_x[i] = 0;
			x->x1_y[i] = 0;	
			x->x1_a1[i] = 0;
			x->x1_a2[i] = 0;
			x->x1_a3[i] = 0;
			x->x1_a4[i] = 0;
			x->x1_a5[i] = 0;
			x->x1_a6[i] = 0;
		}
		SETFLOAT(at,	i);
		SETFLOAT(at+1,	x->x1_x[i]);
		SETFLOAT(at+2,	x->x1_y[i]);
		SETFLOAT(at+3,	x->x1_a1[i]);
		SETFLOAT(at+4,	x->x1_a2[i]);
		SETFLOAT(at+5,	x->x1_a3[i]);
		SETFLOAT(at+6,	x->x1_a4[i]);
		SETFLOAT(at+7,	x->x1_a5[i]);
		SETFLOAT(at+8,	x->x1_a6[i]);
		outlet_list(x->out01, 0, 9, at);
	}
	for (i = 0; i < x->report; i++) {
		x->x2_s[i] = 0;
		x->x2_x[i] = 0;
		x->x2_y[i] = 0;
	}
}

t_class *fill0s_class;

void *fill0s_new(t_symbol *selector, int argcount, t_atom *argvec)
{
    t_fill0s *x = (t_fill0s *)pd_new(fill0s_class);
	x->prev_pts = x->pts = 0;
	int i;
	if (argcount == 0) {
		x->report = 10;
	//	post("report: %d", (int) x->report);
	}
	else {
		for (i = 0; i < argcount; i++) {
			if (argvec[i].a_type == A_FLOAT) {
				post("report: %d", (int) argvec[i].a_w.w_float);
				if (i == 0)	{x->report = (int) argvec[i].a_w.w_float;}
			}
		}
	}
	x->out01 = outlet_new(&x->x_ob, &s_list);
    return (void *)x;
}

void fill0s_setup(void)
{
    	/* We specify "A_GIMME" as creation argument for both the creation
	routine and the method (callback) for the "xy" message.  */
    fill0s_class = class_new(gensym("fill0s"), (t_newmethod)fill0s_new,
    	0, sizeof(t_fill0s), 0, A_GIMME, 0);
    class_addmethod(fill0s_class, (t_method)fill0s_in, gensym("in"), A_GIMME, 0);
	class_addmethod(fill0s_class, (t_method)fill0s_spit, gensym("spit"), 0);
}

